<gallery>

  <yield/>

  <script>
    this.currentIndex = 0;
    this.slides = this.tags['gallery-slide'];

    this.slides.forEach(function(slide) {
      slide.on('NEXT', function(event) {
        this.routeToSlide(this.opts.id, ++this.currentIndex);
      }.bind(this));

      slide.on('PREV', function(event) {
        this.routeToSlide(this.opts.id, --this.currentIndex);
      }.bind(this));
    }.bind(this));

    this.on('update', function() {
      var currentIndex = this.currentIndex;
      var sliderId = this.sliderId;
      var maxIndex = this.slides.length -1;

      this.slides.forEach(function(slide, index) {
        slide.update({
          index: index,
          currentIndex: currentIndex,
          maxIndex: maxIndex
        });
      });
    })

    this.scrollIntoView = function() {
      var el = this.root;
      var boundingRect = el.getBoundingClientRect();
      if (boundingRect.bottom <= el.clientHeight/2) {
        el.scrollIntoView();
      }
    }

    this.routeToSlide = function(sliderId, index) {
      if (sliderId) {
        riot.route(sliderId + '/slider-' + index)
      }
      else {
        riot.route('slider-' + index) // legacy routes

      }
    }

    // register routing:
    riot.route('*/slider-*', function(sliderId, index) {
      if (sliderId === this.opts.id) {
        this.update({currentIndex: index, sliderId});
        this.scrollIntoView();
      }
    }.bind(this));

    // register alternative routing, inherited from a legacy gallery system:
    // (does not work well with multiple sliders on a single page)
    riot.route('slider-*', function(index) {
      this.update({currentIndex: index});
      this.scrollIntoView();
    }.bind(this));

    riot.route.start(true);

  </script>

</gallery>

<gallery-slide class="gallery-slide
  { -fade: cardIndex == -1,
  -slide-0: cardIndex == 0,
  -slide-1: cardIndex == 1,
  -slide-2: cardIndex == 2 }">

  <yield/>

  <gallery-controls class="gallery-controls">
    <button if={ index > 0 } class="gallery-controls__prev" onclick={ prev }>
      previous
    </button>
    <button if={ index < maxIndex } class="gallery-controls__next" onclick={ next }>
      next
    </button>
  </gallery-controls>

  <script>
    next() {
      this.trigger('NEXT');
    }

    prev() {
      this.trigger('PREV');
    }

    lazyLoadImage(isVisible) {
      var lazyImage = this.root.querySelector('img[data-src]');

      if (isVisible && lazyImage) {
        lazyImage.src = lazyImage.getAttribute('data-src');
        lazyImage.removeAttribute('data-src');
      }
    }

    this.on('update', function() {
      this.cardIndex = this.index - this.currentIndex;
      this.isVisible = this.cardIndex >= 0 && this.cardIndex <= 2;
      this.lazyLoadImage(this.isVisible);
    });
  </script>

</gallery-slide>
